// This file is part of the Orbbec Astra SDK [https://orbbec3d.com]
// Copyright (c) 2015-2017 Orbbec 3D
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// Be excellent to each other.
#ifndef ASTRA_HPP
#define ASTRA_HPP

#include "Vector.hpp"
#include "Matrix3x3.hpp"
#include "DeviceController.hpp"
#include "streams/Body.hpp"
#include "streams/Color.hpp"
#include "streams/Depth.hpp"
#include "streams/Infrared.hpp"
#include "streams/Hand.hpp"
#include "streams/DebugHand.hpp"
#include "streams/Point.hpp"
#include "streams/MaskedColor.hpp"
#include "streams/ColorizedBody.hpp"

/**
 * \defgroup cpp_basic_types_ref basic types
 * \ingroup cpp_ref

 * \defgroup cpp_low_api_ref low level stream apis
 * \ingroup cpp_ref
 *
 * \defgroup cpp_high_api_ref high level stream apis
 * \ingroup cpp_ref
 *
 * \defgroup cpp_core_api_ref astra core apis
 * \ingroup cpp_ref
 */

#endif /* ASTRA_HPP */
